Ctxpopup

- Main Page
- Related Pages
- Data Structures
- Files
- Examples

Functions
Ctxpopup

Context popup widget. More...

## Functions
Evas_Object * | elm_ctxpopup_add (Evas_Object *parent)
| Add a new Ctxpopup object to the parent. More...
EOAPI void | elm_obj_ctxpopup_horizontal_set (Eina_Bool horizontal)
| Change the ctxpopup's orientation to horizontal or vertical. More...
EOAPI Eina_Bool | elm_obj_ctxpopup_horizontal_get (void)
| Get the value of current ctxpopup object's orientation. More...
EOAPI void | elm_obj_ctxpopup_auto_hide_disabled_set (Eina_Bool disabled)
| Set ctxpopup auto hide mode triggered by ctxpopup policy. More...
EOAPI Eina_Bool | elm_obj_ctxpopup_auto_hide_disabled_get (void)
| Get ctxpopup auto hide mode triggered by ctxpopup policy. More...
EOAPI void | elm_obj_ctxpopup_hover_parent_set (Evas_Object *parent)
| Set the Ctxpopup's parent. More...
EOAPI Evas_Object * | elm_obj_ctxpopup_hover_parent_get (void)
| Get the Ctxpopup's parent. More...
EOAPI void | elm_obj_ctxpopup_direction_priority_set (Elm_Ctxpopup_Direction first, Elm_Ctxpopup_Direction second, Elm_Ctxpopup_Direction third, Elm_Ctxpopup_Direction fourth)
| Set the direction priority of a ctxpopup. More...
EOAPI void | elm_obj_ctxpopup_direction_priority_get (Elm_Ctxpopup_Direction *first, Elm_Ctxpopup_Direction *second, Elm_Ctxpopup_Direction *third, Elm_Ctxpopup_Direction *fourth)
| Get the direction priority of a ctxpopup. More...
EOAPI Elm_Ctxpopup_Direction | elm_obj_ctxpopup_direction_get (void)
| Get the current direction of a ctxpopup. More...
EOAPI const Eina_List * | elm_obj_ctxpopup_items_get (void)
| Get the internal list of items in a given ctxpopup widget. More...
EOAPI Elm_Object_Item * | elm_obj_ctxpopup_first_item_get (void)
| Get the first item in the given ctxpopup widget's list of items. More...
EOAPI Elm_Object_Item * | elm_obj_ctxpopup_last_item_get (void)
| Get the last item in the given ctxpopup widget's list of items. More...
EOAPI void | elm_obj_ctxpopup_clear (void)
| Clear all items in the given ctxpopup object.
EOAPI Elm_Object_Item * | elm_obj_ctxpopup_item_append (const char *label, Evas_Object *icon, Evas_Smart_Cb func, const void *data)
| Add a new item to a ctxpopup object. More...
EOAPI Elm_Object_Item * | elm_obj_ctxpopup_item_prepend (const char *label, Evas_Object *icon, Evas_Smart_Cb func, const void *data)
| Prepend a new item to a ctxpopup object. More...
void | elm_ctxpopup_horizontal_set (Elm_Ctxpopup *obj, Eina_Bool horizontal)
| Change the ctxpopup's orientation to horizontal or vertical. More...
Eina_Bool | elm_ctxpopup_horizontal_get (const Elm_Ctxpopup *obj)
| Get the value of current ctxpopup object's orientation. More...
void | elm_ctxpopup_auto_hide_disabled_set (Elm_Ctxpopup *obj, Eina_Bool disabled)
| Set ctxpopup auto hide mode triggered by ctxpopup policy. More...
Eina_Bool | elm_ctxpopup_auto_hide_disabled_get (const Elm_Ctxpopup *obj)
| Get ctxpopup auto hide mode triggered by ctxpopup policy. More...
void | elm_ctxpopup_hover_parent_set (Elm_Ctxpopup *obj, Evas_Object *parent)
| Set the Ctxpopup's parent. More...
Evas_Object * | elm_ctxpopup_hover_parent_get (const Elm_Ctxpopup *obj)
| Get the Ctxpopup's parent. More...
void | elm_ctxpopup_direction_priority_set (Elm_Ctxpopup *obj, Elm_Ctxpopup_Direction first, Elm_Ctxpopup_Direction second, Elm_Ctxpopup_Direction third, Elm_Ctxpopup_Direction fourth)
| Set the direction priority of a ctxpopup. More...
void | elm_ctxpopup_direction_priority_get (const Elm_Ctxpopup *obj, Elm_Ctxpopup_Direction *first, Elm_Ctxpopup_Direction *second, Elm_Ctxpopup_Direction *third, Elm_Ctxpopup_Direction *fourth)
| Get the direction priority of a ctxpopup. More...
Elm_Ctxpopup_Direction | elm_ctxpopup_direction_get (const Elm_Ctxpopup *obj)
| Get the current direction of a ctxpopup. More...
const Eina_List * | elm_ctxpopup_items_get (const Elm_Ctxpopup *obj)
| Get the internal list of items in a given ctxpopup widget. More...
Elm_Object_Item * | elm_ctxpopup_first_item_get (const Elm_Ctxpopup *obj)
| Get the first item in the given ctxpopup widget's list of items. More...
Elm_Object_Item * | elm_ctxpopup_last_item_get (const Elm_Ctxpopup *obj)
| Get the last item in the given ctxpopup widget's list of items. More...
void | elm_ctxpopup_clear (Elm_Ctxpopup *obj)
| Clear all items in the given ctxpopup object.
Elm_Object_Item * | elm_ctxpopup_item_append (Elm_Ctxpopup *obj, const char *label, Evas_Object *icon, Evas_Smart_Cb func, const void *data)
| Add a new item to a ctxpopup object. More...
Elm_Object_Item * | elm_ctxpopup_item_prepend (Elm_Ctxpopup *obj, const char *label, Evas_Object *icon, Evas_Smart_Cb func, const void *data)
| Prepend a new item to a ctxpopup object. More...
EOAPI Elm_Object_Item * | elm_obj_ctxpopup_item_prev_get (void)
| Get the item before `it` in a ctxpopup widget's internal list of items. More...
EOAPI Elm_Object_Item * | elm_obj_ctxpopup_item_next_get (void)
| Get the item after `it` in a ctxpopup widget's internal list of items. More...
Elm_Object_Item * | elm_ctxpopup_item_prev_get (const Elm_Ctxpopup_Item *obj)
| Get the item before `it` in a ctxpopup widget's internal list of items. More...
Elm_Object_Item * | elm_ctxpopup_item_next_get (const Elm_Ctxpopup_Item *obj)
| Get the item after `it` in a ctxpopup widget's internal list of items. More...

## Detailed Description

Context popup widget.

A ctxpopup is a widget that, when shown, pops up a list of items. It automatically chooses an area inside its parent object's view (set via elm_ctxpopup_add() and elm_ctxpopup_hover_parent_set()) to optimally fit into it. In the default theme, it will also point an arrow to it's top left position at the time one shows it. Ctxpopup items have a label and/or an icon. It is intended for a small number of items (hence the use of list, not genlist).

This widget inherits from the Layout one, so that all the functions acting on it also work for context popup objects (since 1.8).

This widget emits the following signals, besides the ones sent from Layout:

- `"dismissed"` - This is called when 1. the outside of ctxpopup was clicked or 2. its parent area is changed or 3. the language is changed and also when

1. the parent object is resized due to the window rotation. Then ctxpopup is dismissed.

- `"language,changed"` - This is called when the program's language is changed.
- `"focused"` - When the ctxpopup has received focus. (since 1.8)
- `"unfocused"` - When the ctxpopup has lost focus. (since 1.8) Default content parts of the ctxpopup widget that you can use for are:
  - "default" - A content of the ctxpopup
  Default content parts of the ctxpopup items that you can use for are:
  - "icon" - An icon in the title area
  Default text parts of the ctxpopup items that you can use for are:
  - "default" - A title label in the title area
  Supported elm_object common APIs.
  - elm_object_disabled_set
  - elm_object_disabled_get
  Supported elm_object_item common APIs.
  - elm_object_item_del
  - elm_object_item_disabled_set
  - elm_object_item_disabled_get
  - elm_object_item_part_text_set
  - elm_object_item_part_text_get
  - elm_object_item_part_content_set
  - elm_object_item_part_content_get
  - elm_object_item_signal_emit
  Ctxpopup example shows the usage of a good deal of the API.

## Function Documentation

Evas_Object* elm_ctxpopup_add | ( | Evas_Object * | parent | ) |

Add a new Ctxpopup object to the parent.

Parameters

  parent | Parent object

Returns
  New object or `NULL`, if it cannot be created

Eina_Bool elm_ctxpopup_auto_hide_disabled_get | ( | const Elm_Ctxpopup * | obj | ) |

Get ctxpopup auto hide mode triggered by ctxpopup policy.

Since
  1.9

Returns
  auto hide mode's state of a ctxpopup

See also
  elm_ctxpopup_auto_hide_disabled_set() for more information.

References elm_obj_ctxpopup_auto_hide_disabled_get().

void elm_ctxpopup_auto_hide_disabled_set | ( | Elm_Ctxpopup * | obj,
|  | Eina_Bool | disabled
| ) |  |

Set ctxpopup auto hide mode triggered by ctxpopup policy.

Since
  1.9

Use this function when user wants ctxpopup not to hide automatically. By default, ctxpopup is dismissed whenever mouse clicked its background area, language is changed, and its parent geometry is updated(changed). Not to hide ctxpopup automatically, disable auto hide function by calling this API, then ctxpopup won't be dismissed in those scenarios.

Default value of disabled is `EINA_FALSE`.

See also
  elm_ctxpopup_auto_hide_disabled_get()

Parameters

  [in] | disabled | auto hide enable/disable.

References elm_obj_ctxpopup_auto_hide_disabled_set().

Elm_Ctxpopup_Direction elm_ctxpopup_direction_get | ( | const Elm_Ctxpopup * | obj | ) |

Get the current direction of a ctxpopup.

Returns
  current direction of a ctxpopup (If getting the current direction is failed, it returns #ELM_CTXPOPUP_DIRECTION_UNKNOWN)

Warning
  Once the ctxpopup showed up, the direction would be determined

References elm_obj_ctxpopup_direction_get().

void elm_ctxpopup_direction_priority_get | ( | const Elm_Ctxpopup * | obj,
|  | Elm_Ctxpopup_Direction * | first,
|  | Elm_Ctxpopup_Direction * | second,
|  | Elm_Ctxpopup_Direction * | third,
|  | Elm_Ctxpopup_Direction * | fourth
| ) |  |

Get the direction priority of a ctxpopup.

See also
  elm_ctxpopup_direction_priority_set() for more information.

Parameters

  [out] | first | 1st priority of direction
  [out] | second | 2nd priority of direction
  [out] | third | 3th priority of direction
  [out] | fourth | 4th priority of direction

References elm_obj_ctxpopup_direction_priority_get().

void elm_ctxpopup_direction_priority_set | ( | Elm_Ctxpopup * | obj,
|  | Elm_Ctxpopup_Direction | first,
|  | Elm_Ctxpopup_Direction | second,
|  | Elm_Ctxpopup_Direction | third,
|  | Elm_Ctxpopup_Direction | fourth
| ) |  |

Set the direction priority of a ctxpopup.

This functions gives a chance to user to set the priority of ctxpopup showing direction. This doesn't guarantee the ctxpopup will appear in the requested direction.

See also
  Elm_Ctxpopup_Direction

Parameters

  [in] | first | 1st priority of direction
  [in] | second | 2nd priority of direction
  [in] | third | 3th priority of direction
  [in] | fourth | 4th priority of direction

References elm_obj_ctxpopup_direction_priority_set().

Elm_Object_Item* elm_ctxpopup_first_item_get | ( | const Elm_Ctxpopup * | obj | ) |

Get the first item in the given ctxpopup widget's list of items.

Since
  1.11

Returns
  The first item or `NULL`, if it has no items (and on errors)

See also
  elm_ctxpopup_item_append()
  elm_ctxpopup_last_item_get()

References elm_obj_ctxpopup_first_item_get().

Eina_Bool elm_ctxpopup_horizontal_get | ( | const Elm_Ctxpopup * | obj | ) |

Get the value of current ctxpopup object's orientation.

Returns
  `EINA_TRUE` for horizontal mode, `EINA_FALSE` for vertical mode (or errors)

See also
  elm_ctxpopup_horizontal_set()

References elm_obj_ctxpopup_horizontal_get().

void elm_ctxpopup_horizontal_set | ( | Elm_Ctxpopup * | obj,
|  | Eina_Bool | horizontal
| ) |  |

Change the ctxpopup's orientation to horizontal or vertical.

Parameters

  [in] | horizontal | `EINA_TRUE` for horizontal mode, `EINA_FALSE` for vertical

References elm_obj_ctxpopup_horizontal_set().

Evas_Object* elm_ctxpopup_hover_parent_get | ( | const Elm_Ctxpopup * | obj | ) |

Get the Ctxpopup's parent.

See also
  elm_ctxpopup_hover_parent_set() for more information

References elm_obj_ctxpopup_hover_parent_get().

void elm_ctxpopup_hover_parent_set | ( | Elm_Ctxpopup * | obj,
|  | Evas_Object * | parent
| ) |  |

Set the Ctxpopup's parent.

Set the parent object.

Note
  elm_ctxpopup_add() will automatically call this function with its `parent` argument.

See also
  elm_ctxpopup_add()
  elm_hover_parent_set()

Parameters

  [in] | parent | The parent to use

References elm_obj_ctxpopup_hover_parent_set().

Elm_Object_Item* elm_ctxpopup_item_append | ( | Elm_Ctxpopup * | obj,
|  | const char * | label,
|  | Evas_Object * | icon,
|  | Evas_Smart_Cb | func,
|  | const void * | data
| ) |  |

Add a new item to a ctxpopup object.

Returns
  A handle to the item added or `NULL`, on errors

Warning
  Ctxpopup can't hold both an item list and a content at the same time. When an item is added, any previous content will be removed.

See also
  elm_object_content_set()

Parameters

  [in] | label | The Label of the new item
  [in] | icon | Icon to be set on new item
  [in] | func | Convenience function called when item selected
  [in] | data | Data passed to `func`

References elm_obj_ctxpopup_item_append().

Elm_Object_Item* elm_ctxpopup_item_next_get | ( | const Elm_Ctxpopup_Item * | obj | ) |

Get the item after `it` in a ctxpopup widget's internal list of items.

See also
  elm_ctxpopup_item_prev_get()

Since
  1.11

References elm_obj_ctxpopup_item_next_get().

Elm_Object_Item* elm_ctxpopup_item_prepend | ( | Elm_Ctxpopup * | obj,
|  | const char * | label,
|  | Evas_Object * | icon,
|  | Evas_Smart_Cb | func,
|  | const void * | data
| ) |  |

Prepend a new item to a ctxpopup object.

Since
  1.11

Returns
  A handle to the item added or `NULL`, on errors

Warning
  Ctxpopup can't hold both an item list and a content at the same time. When an item is added, any previous content will be removed.

See also
  elm_object_content_set()

Parameters

  [in] | label | The Label of the new item
  [in] | icon | Icon to be set on new item
  [in] | func | Convenience function called when item selected
  [in] | data | Data passed to `func`

References elm_obj_ctxpopup_item_prepend().

Elm_Object_Item* elm_ctxpopup_item_prev_get | ( | const Elm_Ctxpopup_Item * | obj | ) |

Get the item before `it` in a ctxpopup widget's internal list of items.

See also
  elm_ctxpopup_item_next_get()

Since
  1.11

References elm_obj_ctxpopup_item_prev_get().

const Eina_List* elm_ctxpopup_items_get | ( | const Elm_Ctxpopup * | obj | ) |

Get the internal list of items in a given ctxpopup widget.

Since
  1.11

Returns
  The list of items (Elm_Object_Item as data) or `NULL` on errors.

This list is not to be modified in any way and must not be freed. Use the list members with functions like elm_object_item_text_set(), elm_object_item_text_get(), elm_object_item_del().

Warning
  This list is only valid until `obj` object's internal items list is changed. It should be fetched again with another call to this function when changes happen.

References elm_obj_ctxpopup_items_get().

Elm_Object_Item* elm_ctxpopup_last_item_get | ( | const Elm_Ctxpopup * | obj | ) |

Get the last item in the given ctxpopup widget's list of items.

Since
  1.11

Returns
  The last item or `NULL`, if it has no items (and on errors)

See also
  elm_ctxpopup_item_prepend()
  elm_ctxpopup_first_item_get()

References elm_obj_ctxpopup_last_item_get().

EOAPI Eina_Bool elm_obj_ctxpopup_auto_hide_disabled_get | ( | void |  | ) |

Get ctxpopup auto hide mode triggered by ctxpopup policy.

Since
  1.9

Returns
  auto hide mode's state of a ctxpopup

See also
  elm_ctxpopup_auto_hide_disabled_set() for more information.

Referenced by elm_ctxpopup_auto_hide_disabled_get().

EOAPI void elm_obj_ctxpopup_auto_hide_disabled_set | ( | Eina_Bool | disabled | ) |

Set ctxpopup auto hide mode triggered by ctxpopup policy.

Since
  1.9

Use this function when user wants ctxpopup not to hide automatically. By default, ctxpopup is dismissed whenever mouse clicked its background area, language is changed, and its parent geometry is updated(changed). Not to hide ctxpopup automatically, disable auto hide function by calling this API, then ctxpopup won't be dismissed in those scenarios.

Default value of disabled is `EINA_FALSE`.

See also
  elm_ctxpopup_auto_hide_disabled_get()

Parameters

  [in] | disabled | auto hide enable/disable.

Referenced by elm_ctxpopup_auto_hide_disabled_set().

EOAPI Elm_Ctxpopup_Direction elm_obj_ctxpopup_direction_get | ( | void |  | ) |

Get the current direction of a ctxpopup.

Returns
  current direction of a ctxpopup (If getting the current direction is failed, it returns #ELM_CTXPOPUP_DIRECTION_UNKNOWN)

Warning
  Once the ctxpopup showed up, the direction would be determined

Referenced by elm_ctxpopup_direction_get().

EOAPI void elm_obj_ctxpopup_direction_priority_get | ( | Elm_Ctxpopup_Direction * | first,
|  | Elm_Ctxpopup_Direction * | second,
|  | Elm_Ctxpopup_Direction * | third,
|  | Elm_Ctxpopup_Direction * | fourth
| ) |  |

Get the direction priority of a ctxpopup.

See also
  elm_ctxpopup_direction_priority_set() for more information.

Parameters

  [out] | first | 1st priority of direction
  [out] | second | 2nd priority of direction
  [out] | third | 3th priority of direction
  [out] | fourth | 4th priority of direction

Referenced by elm_ctxpopup_direction_priority_get().

EOAPI void elm_obj_ctxpopup_direction_priority_set | ( | Elm_Ctxpopup_Direction | first,
|  | Elm_Ctxpopup_Direction | second,
|  | Elm_Ctxpopup_Direction | third,
|  | Elm_Ctxpopup_Direction | fourth
| ) |  |

Set the direction priority of a ctxpopup.

This functions gives a chance to user to set the priority of ctxpopup showing direction. This doesn't guarantee the ctxpopup will appear in the requested direction.

See also
  Elm_Ctxpopup_Direction

Parameters

  [in] | first | 1st priority of direction
  [in] | second | 2nd priority of direction
  [in] | third | 3th priority of direction
  [in] | fourth | 4th priority of direction

Referenced by elm_ctxpopup_direction_priority_set().

EOAPI Elm_Object_Item* elm_obj_ctxpopup_first_item_get | ( | void |  | ) |

Get the first item in the given ctxpopup widget's list of items.

Since
  1.11

Returns
  The first item or `NULL`, if it has no items (and on errors)

See also
  elm_ctxpopup_item_append()
  elm_ctxpopup_last_item_get()

Referenced by elm_ctxpopup_first_item_get().

EOAPI Eina_Bool elm_obj_ctxpopup_horizontal_get | ( | void |  | ) |

Get the value of current ctxpopup object's orientation.

Returns
  `EINA_TRUE` for horizontal mode, `EINA_FALSE` for vertical mode (or errors)

See also
  elm_ctxpopup_horizontal_set()

Referenced by elm_ctxpopup_horizontal_get().

EOAPI void elm_obj_ctxpopup_horizontal_set | ( | Eina_Bool | horizontal | ) |

Change the ctxpopup's orientation to horizontal or vertical.

Parameters

  [in] | horizontal | `EINA_TRUE` for horizontal mode, `EINA_FALSE` for vertical

Referenced by elm_ctxpopup_horizontal_set().

EOAPI Evas_Object* elm_obj_ctxpopup_hover_parent_get | ( | void |  | ) |

Get the Ctxpopup's parent.

See also
  elm_ctxpopup_hover_parent_set() for more information

Referenced by elm_ctxpopup_hover_parent_get().

EOAPI void elm_obj_ctxpopup_hover_parent_set | ( | Evas_Object * | parent | ) |

Set the Ctxpopup's parent.

Set the parent object.

Note
  elm_ctxpopup_add() will automatically call this function with its `parent` argument.

See also
  elm_ctxpopup_add()
  elm_hover_parent_set()

Parameters

  [in] | parent | The parent to use

Referenced by elm_ctxpopup_hover_parent_set().

EOAPI Elm_Object_Item* elm_obj_ctxpopup_item_append | ( | const char * | label,
|  | Evas_Object * | icon,
|  | Evas_Smart_Cb | func,
|  | const void * | data
| ) |  |

Add a new item to a ctxpopup object.

Returns
  A handle to the item added or `NULL`, on errors

Warning
  Ctxpopup can't hold both an item list and a content at the same time. When an item is added, any previous content will be removed.

See also
  elm_object_content_set()

Parameters

  [in] | label | The Label of the new item
  [in] | icon | Icon to be set on new item
  [in] | func | Convenience function called when item selected
  [in] | data | Data passed to `func`

Referenced by elm_ctxpopup_item_append().

EOAPI Elm_Object_Item* elm_obj_ctxpopup_item_next_get | ( | void |  | ) |

Get the item after `it` in a ctxpopup widget's internal list of items.

See also
  elm_ctxpopup_item_prev_get()

Since
  1.11

Referenced by elm_ctxpopup_item_next_get().

EOAPI Elm_Object_Item* elm_obj_ctxpopup_item_prepend | ( | const char * | label,
|  | Evas_Object * | icon,
|  | Evas_Smart_Cb | func,
|  | const void * | data
| ) |  |

Prepend a new item to a ctxpopup object.

Since
  1.11

Returns
  A handle to the item added or `NULL`, on errors

Warning
  Ctxpopup can't hold both an item list and a content at the same time. When an item is added, any previous content will be removed.

See also
  elm_object_content_set()

Parameters

  [in] | label | The Label of the new item
  [in] | icon | Icon to be set on new item
  [in] | func | Convenience function called when item selected
  [in] | data | Data passed to `func`

Referenced by elm_ctxpopup_item_prepend().

EOAPI Elm_Object_Item* elm_obj_ctxpopup_item_prev_get | ( | void |  | ) |

Get the item before `it` in a ctxpopup widget's internal list of items.

See also
  elm_ctxpopup_item_next_get()

Since
  1.11

Referenced by elm_ctxpopup_item_prev_get().

EOAPI const Eina_List* elm_obj_ctxpopup_items_get | ( | void |  | ) |

Get the internal list of items in a given ctxpopup widget.

Since
  1.11

Returns
  The list of items (Elm_Object_Item as data) or `NULL` on errors.

This list is not to be modified in any way and must not be freed. Use the list members with functions like elm_object_item_text_set(), elm_object_item_text_get(), elm_object_item_del().

Warning
  This list is only valid until `obj` object's internal items list is changed. It should be fetched again with another call to this function when changes happen.

Referenced by elm_ctxpopup_items_get().

EOAPI Elm_Object_Item* elm_obj_ctxpopup_last_item_get | ( | void |  | ) |

Get the last item in the given ctxpopup widget's list of items.

Since
  1.11

Returns
  The last item or `NULL`, if it has no items (and on errors)

See also
  elm_ctxpopup_item_prepend()
  elm_ctxpopup_first_item_get()

Referenced by elm_ctxpopup_last_item_get().